'Test some of the Liberty BASIC v5.0 functions and statements.
'This is not a comprehensive test suite

global failures
phrase$ = "the quick brown fox"

if chr$(32) <> " " then call fail "CHR$"
if mid$("hey there joe", 5) <> "there joe" then call fail "MID$"
if mid$("hey there joe", 5, 5) <> "there" then call fail "MID$"
if left$("123456", 3) <> "123" then call fail "LEFT$"
if right$("123456", 3) <> "456" then call fail "RIGHT$"
if asc("A") <> 65 then call fail "ASC"
if val("-3.14") <> -3.14 then call fail "VAL"
if len("123456") <> 6 then call fail "LEN"
if str$(-3.14) <> "-3.14" then call fail "STR$"
if len(time$()) <> 8 then call fail "TIME$"
if word$(phrase$, 3) <> "brown" then call fail "WORD$" 
if word$(date$(), 3) = "" and word$(date$(), 4) = "" then call fail "DATE$"
if date$("01/17/2005") <> 38002 then call fail "DATE$('01/17/2005')"
if trim$("  testing  ") <> "testing" then call fail "TRIM$"
if upper$("aBcDeF") <> "ABCDEF" then call fail "UPPER"
if lower$("aBcDeF") <> "abcdef" then call fail "LOWER"
if instr("this is a test", " is") <> 5 then call fail "INSTR"
if abs(-5) <> 5 then call fail "ABS"
if int(3.14) <> 3 then call fail "INT"
if hexdec("FF") <> 255 then call fail "HEXDEC"
if dechex$(255) <> "FF" then call fail "DECHEX$"
if rnd(1) = 0 then call fail "RND"   'a silly test, but better than none 
if using("##.###", 3.14) <> " 3.140" then call fail "USING"
if not(1) then call fail "NOT"
if min(4,8) <> 4 then call fail "MIN"
if max(4,8) <> 8 then call fail "MAX"
if int(sqr(4)) <> 2.0 then call fail "SQR"
if space$(10) <> "          " then call fail "SPACE$"

'eval
if eval("int(cos(3.14)*1000000)") <> -999998 then call fail "EVAL"
if eval$("word$(phrase$, 3)") <> "brown" then call fail "EVAL$"

'trig
if int(sin(2)*1000000) <> 909297 then call fail "SIN"
if int(cos(3.14)*1000000) <> -999998 then call fail "COS"
if int(tan(1)*100000) <> 155740 then call fail "TAN"
if int(asn(1)*10000) <> 15707 then call fail "ASN"
if int(acs(0)*10000) <> 15707 then call fail "ACS"
if int(atn(1)*1000000) <>785398 then call fail "ATN"

'log
if int(log(2)*1000000) <> 693147 then call fail "LOG"
if int(exp(2)*100000) <> 738905 then call fail "EXP"

data the, quick, brown, fox
for x = 1 to 4
  read a$
  if word$("the quick brown fox", x) <> a$ then call fail "READ"
next x
'do it again to test restore
restore
for x = 1 to 4
  read a$
  if word$("the quick brown fox", x) <> a$ then call fail "READ"
next x


'***** test file functions *****

open "testfile.dat" for output as #1
    print #1, "testing";
close #1

open "testfile.dat" for input as #1
    if eof(#1) then call fail "EOF1"
    length = lof(#1)
    if length <> 7 then call fail "LOF"
    a$ = input$(#1, length)
    if eof(#1) = 0 then call fail "EOF2"
close #1
if a$ <> "testing" then call fail "INPUT$"

open "testfile.dat" for output as #1
    print #1, "this/is/a/test";
close #1

open "testfile.dat" for input as #1
    for x = 1 to 4
        position = position + x
        text$ = input$(#1, x)
        if loc(#1) <> position then call fail "LOC"
    next x
close #1

open "testfile.dat" for input as #1
    do
        token$ = inputto$(#1, "/")
        count = count + 1
        if word$("this is a test", count) <> token$ then
            call fail "INPUTTO$"
        end if
    loop until eof(#1)
    if loc(#1) <> lof(#1) then call fail "DO LOOP"
close #1

open "testfile.dat" for random as #1 len = 20
field #1, 8 as dat$, 8 as phone$, 4 as score
dat$ = "01/08/62" : phone$ = "456-7890" : score = 123
put #1, 1
dat$ = "04/18/82" : phone$ = "123-4567" : score = 1123
put #1, 2
dat$ = "12/23/92" : phone$ = "456-6543" : score = 1233
put #1, 3
close #1

open "testfile.dat" for random as #1 len = 20
field #1, 20 as record$
gettrim #1, 1
if record$ <> "01/08/62456-7890123" then call fail "GET"
get #1, 2
if record$ <> "04/18/82123-45671123" then call fail "GET"
get #1, 3
if record$ <> "12/23/92456-65431233" then call fail "GET"
close #1

'do it again, differently
open "testfile.dat" for random as #1 len = 20
field #1, 8 as dat$, 8 as phone$, 4 as score
get #1, 1
record$ = dat$ + phone$ + str$(score)
if record$ <> "01/08/62456-7890123" then call fail "GET"
get #1, 2
record$ = dat$ + phone$ + str$(score)
if record$ <> "04/18/82123-45671123" then call fail "GET"
get #1, 3
record$ = dat$ + phone$ + str$(score)
if record$ <> "12/23/92456-65431233" then call fail "GET"
close #1

open "testfile.dat" for output as #1
print #1, "This is a test of the emergency broadcast system."
close #1

open "testfile.dat" for output as #1
print #1, "this,is,a,test";
close #1

open "testfile.dat" for input as #1
if lof(#1) <> 14 then call fail "File too long"
while eof(#1) = 0
    item = item + 1
    input #1, a$
    if word$("this is a test", item) <> a$ then call fail "INPUT #"
wend
close #1

if dirExists("testdir") then
    print "Directory testdir should not exist.  Creation test skipped."
  else
    if mkdir("testdir") <> 0 then call fail "MKDIR1"
    if dirExists("testdir") = 0 then call fail "MKDIR2"
end if

select case rmdir("testdir")
  case 0
    if dirExists("testdir") = 1 then call fail "RMDIR2"
  case else
    call fail "RMDIR1"
end select

open "namekill.txt" for output as #1
print #1, "testing"
close #1

on error goto [nameOrKillHandler]
name "namekill.txt" as "nowkill.txt"
kill "nowkill.txt"
goto [zeroDivideTest]

[nameOrKillHandler]
print Err$
call fail "NAME AS"

[zeroDivideTest]
on error goto [handler]
a = 1 / 0
call fail "ON ERROR GOTO"
goto [BitwiseTests]

[handler]
if Err$ <> "Division by zero" then call fail "ON ERROR GOTO"

[BitwiseTests]
if (21 and 24) <> 16 then call fail "Bitwise AND"
if (27 or 12) <> 31 then call fail "Bitwise OR"
if (31 xor 21) <> 10 then call fail "Bitwise XOR"

gosub [testExit]

print "Total failures: "; failures

end

sub fail descr$
    failures = failures + 1
    print descr$; " failed."
end sub

function dirExists(dirname$)
    dim info$(10, 10)
    files DefaultDir$, "*", info$()
    if (info$(0, 1)) <> "0" then
        fileCount = val(info$(0, 0))
        dirCount = val(info$(0, 1))
        for x = fileCount+1 to fileCount+dirCount
            if info$(x, 1) = dirname$ then dirExists = 1
        next x
    end if
end function

function fileExists(filename$)
    dim info$(10, 10)
    files DefaultDir$, filename$, info$()
    if (info$(0, 0)) <> "0" then fileExists = 1
end function

sub 
print 5
end sub

[testExit]

for x = 1 to 10
    if x = 5 then exit for
next x
if x <> 5 then call fail "EXIT FOR"

while 1  'loop forever
    x = x + 1
    if x = 15 then exit while
wend
if x <> 15 then call fail "EXIT WHILE"

return